<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 06/11/12
 * Time: 11:23
 * To change this template use File | Settings | File Templates.
 */

namespace Estoque\Logic\FechamentoDia;

use Geral\Entities\Ferifili;

use \Geral\Util\DateUtil;


class Util
{


    CONST FORMATEDATE_EN = 'y-MM-dd';
    CONST LOCALE = 'en_US';

    public $primeiroDiaMes;
    public $ultimoDiaMes;


    /**
     * Verifica se uma determinada data é feriado para a filial.
     *
     * @param $filial
     * @param $nrorg
     * @param $data
     *
     * @return bool|string
     */
    public function verificaFeriado($filial, $nrorg, $data){
        $objFeri = Ferifili::getObject(
            array(
                'cdfilial' => $filial,
                'nrorg' => $nrorg,
                'dtferifili' => $data,
            )
        );

        /** @var $objFeri Ferifili */
        if ($objFeri) {
            return $objFeri->getDtferifili()->format('Y-m-d');
        } else {
            return false;
        }
    }


    /**
     * Retorna o primeiro e ultimo dia do mes de uma data.
     *
     * @param $dtRef
     *
     * @return array
     */
    public function primeiroUltimoDiaMes($dtRef = null){
        if (empty($dtRef) === true) {
            $dtRef = now();
        }

        $primeiroDia = DateUtil::getPrimeiroDiaDoMes(DateUtil::getDataDeString($dtRef));
        $this->primeiroDiaMes = $primeiroDia->format(DateUtil::FORMATO_BRASILEIRO);

        $ultimoDia = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtRef));
        $this->ultimoDiaMes = $ultimoDia->format(DateUtil::FORMATO_BRASILEIRO);

        return $this;
    }


}
