<?php
namespace Fiscal\Logic\Sped\Exceptions;

class ExcecaoSped extends \Fiscal\Logic\Exception
{
    private $messageName;

    public function __construct($messageName, $code = 0, \Exception $previous = null)
    {
        parent::__construct($messageName, $code, $previous);
        $this->messageName = $messageName;
    }
    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    public static function Validacao01(){
        throw new self ('msg_pbi00137_01'); //Parâmetro não pode ser excluído, apenas alterado.
    }

    public static function Validacao02(){
        throw new self ('msg_pbi00137_02'); //O campo apropriação de crédito deve ser preenchido.
    }

    public static function Validacao03(){
        throw new self ('msg_pbi00137_03'); //O campo Critério de Escrituração deve ser preenchido.
    }

}