/* Sistemas Integrados TEKNISA
  Documentos Fiscais de Entrada

Nome: 0010_APTSTPO.SQL

@C:\web_550\sql\end_conv\oracle\clientes\apt\0010_APTSTPO_GERA_RD.SQL

Descrio:
Criao do procedimento GERA_RD para gerao do nmero RD para cada nota fiscal
de entrada ou conta a pagar lanada no sistema Contas a Pagar.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
04/03/2013 - Fabrcio Marcelo da Silva
*/

create or replace PROCEDURE USR_GERA_RD
(
   P_CDFILIAL      IN VARCHAR2,
   P_DTINICIAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL       IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTINILANC     IN NOTAFISCAL.DTCOMPFATUR%TYPE,
   P_DTFINLANC     IN NOTAFISCAL.DTCOMPFATUR%TYPE,
   P_TDTLANC       IN VARCHAR2,
   P_CDFORNECED    IN VARCHAR2,
   P_TCDFORNECED   IN VARCHAR2,
   P_CDOPERADOR    IN VARCHAR2,
   P_TCDOPERADOR   IN VARCHAR2,
   P_CDTIPOOPER    IN VARCHAR2,
   P_TCDTIPOOPER   IN VARCHAR2)
IS
   V_NOVOCODIGO  INTEGER;
BEGIN
   IF NOT P_CDFILIAL IS NULL THEN
      FOR C_NFCPAG IN (SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA, NF.DTENTRSAID AS DATA,
                              CP.DTATUAVENPAG, NF.CDFILIRECE
                         FROM NOTAFISCAL NF, CONTAPAGAR CP, FILIAL F, TIPOOPERAC T, FORNECEDOR FO, 
                              (SELECT CDFILIAL
                                 FROM FILIAL
                                WHERE CDFILIAL = P_CDFILIAL) LF
                        WHERE  NF.CDFILIRECE = LF.CDFILIAL
                          AND (NF.IDENTRSAIDOP  = 'E')
                          AND (NF.IDSISTEMA     = 'DFE')
                          AND (NF.IDORIGDESTNF = 'F')
                          AND NF.DTENTRSAID    BETWEEN P_DTINICIAL AND P_DTFINAL
                          AND ((NF.DTCOMPFATUR BETWEEN P_DTINILANC AND P_DTFINLANC) OR (P_TDTLANC = 'T'))
                          AND ((INSTR(P_CDFORNECED, '_'||FO.CDFORNECED||'_') > 0) OR (P_TCDFORNECED = 'T'))
                          AND NF.CDFORNECED    = FO.CDFORNECED
                          AND ((INSTR(P_CDOPERADOR, '_'||NF.CDOPERGERA||'_') > 0) OR (P_TCDOPERADOR = 'T'))
                          AND ((INSTR(P_CDTIPOOPER, '_'||T.CDTIPOOPER||'_') > 0) OR (P_TCDTIPOOPER = 'T'))
                          AND NF.IDENTRSAIDOP  = T.IDENTRSAIDOP
                          AND NF.CDTIPOOPER    = T.CDTIPOOPER
                          AND CP.CDFILIAL = NF.CDFILIAL
                          AND CP.NRLANCTONF = NF.NRLANCTONF
                          AND F.CDFILIAL       = NF.CDFILIRECE
                          AND CP.USR_IDNUMERORD IS NULL

                        UNION

                       SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA, CP.DTATUAVENPAG AS DATA,
                              CP.DTATUAVENPAG, NF.CDFILIRECE
                         FROM NOTAFISCAL NF, CONTAPAGAR CP, FILIAL F, TIPOOPERAC T, FORNECEDOR FO,
                              (SELECT CDFILIAL
                                 FROM FILIAL
                                WHERE CDFILIAL = P_CDFILIAL) LF
                        WHERE NF.NRLANCTONF    = CP.NRLANCTONF
                          AND NF.CDTIPOOPER    = T.CDTIPOOPER
                          AND NF.IDENTRSAIDOP  = T.IDENTRSAIDOP
                          AND CP.CDFILIAL      = NF.CDFILIAL
                          AND NF.CDFILIRECE    = LF.CDFILIAL
                          AND NF.CDFORNECED    = FO.CDFORNECED
                          AND (NF.IDENTRSAIDOP  = 'E')
                          AND (NF.IDSISTEMA     = 'PAG')
                          AND (NVL(NF.IDORIGDESTNF, 'F') = 'F')
                          AND F.CDFILIAL       = NVL(P_CDFILIAL, CP.CDFILIAL)
                          AND NF.DTENTRSAID     BETWEEN P_DTINICIAL AND P_DTFINAL
                          AND ((NF.DTLANCAMENNF BETWEEN P_DTINILANC AND P_DTFINLANC) OR (P_TDTLANC = 'T'))
                          AND ((INSTR(P_CDFORNECED, '_'||FO.CDFORNECED||'_') > 0) OR (P_TCDFORNECED = 'T'))
                          AND ((INSTR(P_CDOPERADOR, '_'||NF.CDOPERACTPG||'_') > 0) OR (P_TCDOPERADOR = 'T'))
                          AND ((INSTR(P_CDTIPOOPER, '_'||T.CDTIPOOPER||'_') > 0) OR (P_TCDTIPOOPER = 'T'))
                          AND CP.USR_IDNUMERORD IS NULL
                        ORDER BY CDEMPRESA, CDFILIRECE, DATA, DTATUAVENPAG
      ) LOOP

        /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT USR_IDNUMERORD.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         UPDATE CONTAPAGAR
            SET USR_IDNUMERORD = V_NOVOCODIGO
          WHERE CDFILIAL = C_NFCPAG.CDFILIAL
            AND NRLANCTONF = C_NFCPAG.NRLANCTONF
            AND DTATUAVENPAG = C_NFCPAG.DTATUAVENPAG;

      END LOOP;
      COMMIT;
   ELSE
      FOR C_NFCPAG IN (SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA, NF.DTENTRSAID AS DATA,
                              CP.DTATUAVENPAG, NF.CDFILIRECE
                         FROM NOTAFISCAL NF, CONTAPAGAR CP, FILIAL F, TIPOOPERAC T, FORNECEDOR FO,
                              (SELECT CDFILIAL
                                 FROM FILIAL) LF
                        WHERE  NF.CDFILIRECE = LF.CDFILIAL
                          AND (NF.IDENTRSAIDOP  = 'E')
                          AND (NF.IDSISTEMA     = 'DFE')
                          AND (NF.IDORIGDESTNF = 'F')
                          AND NF.DTENTRSAID    BETWEEN P_DTINICIAL AND P_DTFINAL
                          AND ((NF.DTCOMPFATUR BETWEEN P_DTINILANC AND P_DTFINLANC) OR (P_TDTLANC = 'T'))
                          AND ((INSTR(P_CDFORNECED, '_'||FO.CDFORNECED||'_') > 0) OR (P_TCDFORNECED = 'T'))
                          AND NF.CDFORNECED    = FO.CDFORNECED
                          AND ((INSTR(P_CDOPERADOR, '_'||NF.CDOPERGERA||'_') > 0) OR (P_TCDOPERADOR = 'T'))
                          AND ((INSTR(P_CDTIPOOPER, '_'||T.CDTIPOOPER||'_') > 0) OR (P_TCDTIPOOPER = 'T'))
                          AND NF.IDENTRSAIDOP  = T.IDENTRSAIDOP
                          AND NF.CDTIPOOPER    = T.CDTIPOOPER
                          AND CP.CDFILIAL = NF.CDFILIAL
                          AND CP.NRLANCTONF = NF.NRLANCTONF
                          AND F.CDFILIAL       = NF.CDFILIRECE
                          AND CP.USR_IDNUMERORD IS NULL

                        UNION

                       SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA, CP.DTATUAVENPAG AS DATA,
                              CP.DTATUAVENPAG, NF.CDFILIRECE
                         FROM NOTAFISCAL NF, CONTAPAGAR CP, FILIAL F, TIPOOPERAC T, FORNECEDOR FO,
                              (SELECT CDFILIAL
                                 FROM FILIAL) LF
                        WHERE NF.NRLANCTONF    = CP.NRLANCTONF
                          AND NF.CDTIPOOPER    = T.CDTIPOOPER
                          AND NF.IDENTRSAIDOP  = T.IDENTRSAIDOP
                          AND CP.CDFILIAL      = NF.CDFILIAL
                          AND NF.CDFILIRECE    = LF.CDFILIAL
                          AND NF.CDFORNECED    = FO.CDFORNECED
                          AND (NF.IDENTRSAIDOP  = 'E')
                          AND (NF.IDSISTEMA     = 'PAG')
                          AND (NVL(NF.IDORIGDESTNF, 'F') = 'F')
                          AND F.CDFILIAL       = NVL(P_CDFILIAL, CP.CDFILIAL)
                          AND NF.DTENTRSAID     BETWEEN P_DTINICIAL AND P_DTFINAL
                          AND ((NF.DTLANCAMENNF BETWEEN P_DTINILANC AND P_DTFINLANC) OR (P_TDTLANC = 'T'))
                          AND ((INSTR(P_CDFORNECED, '_'||FO.CDFORNECED||'_') > 0) OR (P_TCDFORNECED = 'T'))
                          AND ((INSTR(P_CDOPERADOR, '_'||NF.CDOPERACTPG||'_') > 0) OR (P_TCDOPERADOR = 'T'))
                          AND ((INSTR(P_CDTIPOOPER, '_'||T.CDTIPOOPER||'_') > 0) OR (P_TCDTIPOOPER = 'T'))
                          AND CP.USR_IDNUMERORD IS NULL
                        ORDER BY CDEMPRESA, CDFILIRECE, DATA, DTATUAVENPAG
      ) LOOP

        /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT USR_IDNUMERORD.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         UPDATE CONTAPAGAR
            SET USR_IDNUMERORD = V_NOVOCODIGO
          WHERE CDFILIAL = C_NFCPAG.CDFILIAL
            AND NRLANCTONF = C_NFCPAG.NRLANCTONF
            AND DTATUAVENPAG = C_NFCPAG.DTATUAVENPAG;

      END LOOP;
      COMMIT;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_GERA_RD','5.50.XXX'); END;
/
